/*******************************************************************************************************************************
Copyright (c) 2022 Osita Sunday Nnyigide (osita@protein-science.com)

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
********************************************************************************************************************************/

#include "RepairPDB.hpp"

char OutputStructure::_element(string atom_name)
  {

    for (auto i :atom_name)
      {
        if (!isdigit(i))
          {
            return i;
            break;
          }
      }
  }

string OutputStructure::atomType(string name)
  {
      if (name.size() == 1)      return " "+name+"  ";
      else if (name.size() == 2) return " "+name+" ";
      else if (name.size() == 3) return " "+name;
      else if (name.size() == 4) return  name;
  }

void OutputStructure:: writeOutput(char format, string output)
  {
    int atom_num; int cnum;
    if (format == 'b'|| format =='t')
      {
        ofstream ofile;
        int atom_num = 1;
        if (output == "no") output = "out.pdb";
        ofile.open(output);
        ofile<<setiosflags(ios::fixed)<<setprecision(3);
        ofile<<"# structure generated by PRAS"<<endl;
        for (int i=0;i<chains.size();i++)
          {
            for(int j=0;j<chains[i].res_atom.size();j++)
              {

                ofile<<"ATOM  "<<setw(5)<<atom_num<<" ";
                ofile<<atomType(chains[i].res_atom[j])
                <<" "<<chains[i].res_type<<" "
                <<chains[i].c_id<<setw(4)<<chains[i].res_num
                <<setw(1)<<chains[i].res_insert<<"   ";
                for(int k=0;k<3;k++)
                  {
                    ofile<<setw(8)<<chains[i].res_pos[j][k];
                  }
                ofile<<"  1.00  0.00           "
                <<_element(chains[i].res_atom[j])<<"  "<<endl;
                atom_num++;
              }
              if(i==chains.size()-1)
                  {
                    goto TER;
                  }
              else
                  {
                    if(chains[i].c_id!=chains[i+1].c_id)
                            {
                    TER:          ofile<<"TER   "<<setw(5)<<atom_num<<"      "
                                  <<chains[i].res_type<<" "<<chains[i].c_id<<setw(4)
                                  <<chains[i].res_num<<endl;
                                  atom_num++;
                            }
                  }
          }
        if (_hetatm.size()>0)
          {
            for (auto i:_hetatm)ofile<<i<<endl;
          }
        ofile<<"END";
        ofile.close();
      }
    else if (format == 'f')
      {
        if (output == "no") output = "out.cif";
        cnum = 1; atom_num = 1;
        ofstream ofile;
        ofile.open(output);
        ofile<<setiosflags(ios::fixed)<<setprecision(3);
        ofile<<     "# structure generated by PRAS\n"<<"#"
                    <<"\n"<<"data_xxxx\n" <<"#"<<"\n"
                    <<"_entry.id xxxx\n"<<"#"<<"\n"<<"loop_\n";
        ofile<<"_atom_type.symbol\n";

        for (auto i:symbol)
            {
                ofile<<i<<"\n";
            }
        for (auto i:atom_site)
          {
            ofile<<"_atom_site."<<i<<"\n";
          }
        for (int i=0;i<chains.size();i++)
          {
            if (chains[i].c_id != chains[fabs(i-1)].c_id)
              {
                cnum+=1;
              }
            for(int j=0;j<chains[i].res_atom.size();j++)
              {

                ofile<<"ATOM  "<<atom_num<<" "<<_element(chains[i].res_atom[j])<<" ";
                ofile<<setw(4)<<atomType(chains[i].res_atom[j])<<" "<<". "<<chains[i].res_type
                <<" "<<chains[i].c_id<<" "<<cnum
                <<" "<<chains[i].res_num<<" "<<chains[i].res_insert<<" ";
                for(int k=0;k<3;k++)
                  {
                    ofile<<setw(8)<<chains[i].res_pos[j][k];
                  }
                ofile<<" 1.00 0.00 0"<<" "<<chains[i].res_num<<" "<<chains[i].res_type
                <<" "<<chains[i].c_id<<" "<<setw(4)<<atomType(chains[i].res_atom[j])<<" "<<"1 "
                <<endl;
                atom_num++;
              }
          }
        if (_hetatm.size()>0)
          {
            for (auto i:_hetatm)ofile<<i<<endl;
          }
        ofile<<"#";
        ofile.close();
      }
  }